package main

type TreeNode struct {
	Val   int
	Left  *TreeNode
	Right *TreeNode
}

func traverse(root *TreeNode, res *[]int) {
	if root == nil {
		return
	}
	traverse(root.Left, res)
	*res = append(*res, root.Val)
	traverse(root.Right, res)
}

func kthSmallest(root *TreeNode, k int) int {
	var result []int
	traverse(root, &result)
	return result[k-1]
}
