from collections import defaultdict
from typing import Optional


class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next


class Solution:
    def hasCycle(self, head: Optional[ListNode]) -> bool:
        nodes: set[ListNode] = set()
        cur_node = head
        while cur_node:
            lb = len(nodes)
            nodes.add(cur_node)
            cur_node = cur_node.next
            la = len(nodes)
            if lb == la:
                return True
        return False


if __name__ == "__main__":
    s = Solution()
    e3 = ListNode(3, None)
    e2 = ListNode(2, e3)
    e1 = ListNode(1, e2)
    e0 = ListNode(0, e1)
    # k = [e0, e1, e2, e3]
    nb = s.hasCycle(e0)
    print(nb)
