from typing import Optional


# Definition for singly-linked list.
class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next


class Solution:
    def reverseList(self, head: Optional[ListNode]) -> Optional[ListNode]:
        if not head:
            return None
        if head.next is None:
            return head
        p = head
        c = head
        n = head.next
        while True:
            if p == c:
                p.next = None
                c = n
                n = c.next
            if c.next is None:
                c.next = p
                break
            else:
                c.next = p
                p = c
                c = n
                n = c.next
        return c


if __name__ == "__main__":
    s = Solution()
    e3 = ListNode(3, None)
    e2 = ListNode(2, e3)
    e1 = ListNode(1, e2)
    e0 = ListNode(0, e1)
    k = [e0, e1, e2, e3]
    nb = s.reverseList(e0)
    for index, elem in enumerate(k):
        next_val = elem.next.val if elem.next else "No value"
        print(f"{index} - v: {elem.val} - vn: {next_val}")
