package main

import "fmt"

type TreeNode struct {
	Val   int
	Left  *TreeNode
	Right *TreeNode
}

func traverse(root *TreeNode, res *[]int) {
	if root == nil {
		return
	}
	traverse(root.Left, res)
	*res = append(*res, root.Val)
	traverse(root.Right, res)
}
func inorderTraversal(root *TreeNode) []int {
	var result []int
	traverse(root, &result)
	return result
}

func main() {
	n10 := TreeNode{Val: 2}
	n9 := TreeNode{Val: 5}
	n8 := TreeNode{Val: 7}
	n7 := TreeNode{Val: 6, Left: &n9, Right: &n8}
	n6 := TreeNode{Val: 3, Left: &n10}
	n5 := TreeNode{Val: 4, Left: &n6, Right: &n7}

	res := inorderTraversal(&n5)
	fmt.Print(res)
}
