from typing import Optional


# Definition for singly-linked list.
class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next


class Solution:
    def mergeTwoLists(
        self, list1: Optional[ListNode], list2: Optional[ListNode]
    ) -> Optional[ListNode]:
        if not list1 and not list2:
            return None
        if not list1 and isinstance(list2, ListNode):
            return list2
        if not list2 and isinstance(list1, ListNode):
            return list1
        i = list1
        j = list2
        r = None
        rf = None
        while i or j:
            print(f"i : {i.val if i else 'No value'}\nj : {j.val if j else 'No value'}\n")
            if not j:
                r.next = i
                i = i.next
                r = r.next
                continue
            if not i:
                r.next = j
                j = j.next
                r = r.next
                continue
            if i.val <= j.val:
                if not r:
                    r = i
                    rf = i
                else:
                    r.next = i
                    r = r.next
                i = i.next
            else:
                if not r:
                    r = j
                    rf = j
                else:
                    r.next = j
                    r = r.next
                j = j.next
        return rf


if __name__ == "__main__":
    s = Solution()
    # l12 = ListNode(val=4, next=None)
    # l11 = ListNode(val=2, next=l12)
    # l10 = ListNode(val=1, next=l11)
    #
    # l22 = ListNode(val=5, next=None)
    # l21 = ListNode(val=3, next=l22)
    # l20 = ListNode(val=1, next=l21)

    l11 = ListNode(val=3, next=None)
    l10 = ListNode(val=-9, next=l11)

    l21 = ListNode(val=7, next=None)
    l20 = ListNode(val=5, next=l21)

    k = s.mergeTwoLists(list1=l10, list2=l20)

    while k:
        print(f"{k.val}")
        k = k.next
