from typing import Optional


# Definition for singly-linked list.
class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next


class Solution:
    def mergeTwoLists(self, list1: ListNode, list2: ListNode) -> ListNode:
        dummy = node = ListNode()

        while list1 and list2:
            if list1.val < list2.val:
                node.next = list1
                list1 = list1.next
            else:
                node.next = list2
                list2 = list2.next
            node = node.next

        node.next = list1 or list2

        return dummy.next


if __name__ == "__main__":
    s = Solution()
    # l12 = ListNode(val=4, next=None)
    # l11 = ListNode(val=2, next=l12)
    # l10 = ListNode(val=1, next=l11)
    #
    # l22 = ListNode(val=5, next=None)
    # l21 = ListNode(val=3, next=l22)
    # l20 = ListNode(val=1, next=l21)

    l11 = ListNode(val=3, next=None)
    l10 = ListNode(val=-9, next=l11)

    l21 = ListNode(val=7, next=None)
    l20 = ListNode(val=5, next=l21)

    k = s.mergeTwoLists(list1=l10, list2=l20)

    while k:
        print(f"{k.val}")
        k = k.next
