from typing import List, Optional


class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next


class Solution:
    def removeNthFromEnd(self, head: Optional[ListNode], n: int) -> Optional[ListNode]:
        if not head:
            return None
        if head.next is None:
            return None
        perm_head = head
        nodes = []
        while head:
            nodes.append(head)
            head = head.next
        if n == 1:
            nodes[-2].next = None
            return perm_head
        if n == len(nodes):
            return perm_head.next
        counter = 1 
        for i in range(len(nodes) - 1, 0, -1):
            if counter == n:
                nodes[i - 1].next = nodes[i + 1]
            counter += 1
        return perm_head


if __name__ == "__main__":
    s = Solution()
    e3 = ListNode(3, None)
    e2 = ListNode(2, e3)
    e1 = ListNode(1, e2)
    e0 = ListNode(0, e1)
    fe = s.removeNthFromEnd(e0, 1)
    while fe:
        print(f"{fe.val}")
        fe = fe.next
