from typing import List, Optional


class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next


class Solution:
    def removeNthFromEnd(self, head: Optional[ListNode], n: int) -> Optional[ListNode]:
        N = 0
        cur = head
        while cur:
            N += 1
            cur = cur.next

        removeIndex = N - n
        if removeIndex == 0:
            return head.next

        cur = head
        for i in range(N - 1):
            if (i + 1) == removeIndex:
                cur.next = cur.next.next
                break
            cur = cur.next
        return head


if __name__ == "__main__":
    s = Solution()
    e3 = ListNode(3, None)
    e2 = ListNode(2, e3)
    e1 = ListNode(1, e2)
    e0 = ListNode(0, e1)
    fe = s.removeNthFromEnd(e0, 1)
    while fe:
        print(f"{fe.val}")
        fe = fe.next
